import java.awt.desktop.QuitStrategy;

public class QuickSort<T extends Comparable <? super T>> implements SortInterface<T> {
	
	public static enum PivotType {FirstElement, RandomElement, MidOfFirstMidLastElement}
	
	private PivotType pivotType = PivotType.FirstElement;
	

	@Override
	public void sort(T[] arrayToSort) {
		this.quickSort(arrayToSort, 0, arrayToSort.length - 1);
//		this.showArray("final result", arrayToSort, 0, arrayToSort.length - 1);
	}

	public PivotType getPivotType() {
		return pivotType;
	}

	public void setPivotType(PivotType pivotType) {
		this.pivotType = pivotType;
	}

	/*************************/
	/*    private methods    */
	/*************************/
	
	private void quickSort(T[] array, int first, int last) {
		int pivotIndex;
		if (first < last) {
//			this.showArray("whole", array, first, last);
			pivotIndex = partition(array, first, last);
//			this.showArray("left", array, first, pivotIndex - 1);
			this.quickSort(array, first, pivotIndex - 1);
//			this.showArray("right", array, pivotIndex + 1, last);
			this.quickSort(array, pivotIndex + 1, last);
		}
	}
	
	private int partition(T[] array, int first, int last) {
		this.choosePivot(array, first, last);
		T pivot = array[first];
		T tempItem;
		
		int lastS1 = first;
		
		for ( int firstUnknown = first + 1 ; firstUnknown <= last ; firstUnknown++ ) {
			if (array[firstUnknown].compareTo(pivot) < 0) {
				lastS1++;
				tempItem = array[firstUnknown];
				array[firstUnknown] = array[lastS1];
				array[lastS1] = tempItem;
			}
		}
		
		tempItem = array[first];
		array[first] = array[lastS1];
		array[lastS1] = tempItem;
		
		return lastS1;
	}
	
	// the pivot is always the first element when this function is finished
	private void choosePivot(T[] array, int first, int last) {
		switch (this.pivotType) {
		case FirstElement:
			break;
		case RandomElement:
			// pick a random element from first to last and place it in first element
			break;
		case MidOfFirstMidLastElement:
			// pick the middle of first, mid and last and place it in first element
			break;
		
		}
	}
	
//	private void showArray(String s, T[] array, int first, int last) {
//		System.out.print(s + " - array = [");
//		for ( int i = first ; i <= last ; i++ ) {
//			if(i == last) {
//				System.out.print(array[i]);
//			} else {
//				System.out.print(array[i] + ", ");
//			}
//		}
//		System.out.println("]");
//	}
	
	/*************************/
	/*    main method        */
	/*************************/
	
	public static void main(String[] args) {
		Integer[] array = {14, 22, 15, 8, 9, 5, 2, 17, 29, 44};
		
		QuickSort<Integer> qs = new QuickSort<Integer>();
		qs.sort(array);
	}
}
